Bug 1312151 - Symbols verion behavior changed and breaks linking against libmysqlclient.so
Symbols verion behavior changed and breaks linking against libmysqlclient.so
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: binutils (Show other bugs)
25
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Nick Clifton
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1309199
  Show dependency treegraph
 
Reported: 2016-02-25 16:26 EST by Honza Horak
Modified: 2017-12-12 06:03 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-12-12 06:03:59 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
reproducer.sh that compiles example app (515 bytes, application/x-shellscript)
2016-02-25 16:26 EST, Honza Horak
no flags Details
example library (87 bytes, text/plain)
2016-02-25 16:28 EST, Honza Horak
no flags Details
header file for example library (19 bytes, text/plain)
2016-02-25 16:28 EST, Honza Horak
no flags Details
version script used for linking (152 bytes, text/plain)
2016-02-25 16:29 EST, Honza Horak
no flags Details
test app that links against test library (64 bytes, text/plain)
2016-02-25 16:30 EST, Honza Horak
no flags Details

  None (edit)
Description Honza Horak 2016-02-25 16:26:56 EST
Created attachment 1130663 [details]
reproducer.sh that compiles example app

Description of problem:
In F24 behavior of linker changed somehow, which breaks linking against mariadb's client library:
https://bugzilla.redhat.com/show_bug.cgi?id=1309199

I've reproduced it with the files that I'll attach. It shows that the application linking with a library does not work in runtime on F24. The same reproducer works fine in F23.

Version-Release number of selected component (if applicable):
binutils-2.26-12.fc24.x86_64

How reproducible:
100%

Steps to Reproduce:
1. ./reproducer.sh
2. LD_LIBRARY_PATH="." ./testhello 
3. LD_LIBRARY_PATH="." ldd -r ./testhello 

Actual results:
$> LD_LIBRARY_PATH="." ./testhello 
./testhello: relocation error: ./testhello: symbol hello, version libhello_1 not defined in file libhello.so.0 with link time reference

$> LD_LIBRARY_PATH="." ldd -r ./testhello 
	linux-vdso.so.1 (0x00007ffe70ff2000)
	libhello.so.0 => ./libhello.so.0 (0x00007f5455da6000)
	libc.so.6 => /lib64/libc.so.6 (0x00007f54559ca000)
	/lib64/ld-linux-x86-64.so.2 (0x0000563338912000)
symbol hello, version libhello_1 not defined in file libhello.so.0 with link time reference	(./testhello)


Expected results:
no error during linking

Additional info:
Comment 1 Honza Horak 2016-02-25 16:28 EST
Created attachment 1130664 [details]
example library
Comment 2 Honza Horak 2016-02-25 16:28 EST
Created attachment 1130665 [details]
header file for example library
Comment 3 Honza Horak 2016-02-25 16:29 EST
Created attachment 1130666 [details]
version script used for linking
Comment 4 Honza Horak 2016-02-25 16:30 EST
Created attachment 1130667 [details]
test app that links against test library
Comment 5 Nick Clifton 2016-02-26 08:51:45 EST
Please try:

 binutils-2.26-13.fc24 or
 binutils-2.26-13.fc25

The bug appears to have already been reported as FSF PR 19698:

  https://sourceware.org/bugzilla/show_bug.cgi?id=19698

So I have taken the patch from there and applied it to the Fedora binutils sources.
Comment 6 Honza Horak 2016-03-01 10:10:26 EST
Thanks, scratch build seems fine, now proper build is on the way:
http://koji.fedoraproject.org/koji/taskinfo?taskID=13189307
Comment 7 Jan Kurik 2016-07-26 00:50:16 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 25 development cycle.
Changing version to '25'.
Comment 8 Fedora End Of Life 2017-11-16 14:00:23 EST
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.
Comment 9 Fedora End Of Life 2017-12-12 06:03:59 EST
Fedora 25 changed to end-of-life (EOL) status on 2017-12-12. Fedora 25 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.